// VARIABLES GLOBALES ---------------------------------
// action et composante (face, 0 = toutes) courantes
var mode = 'rien', compos = 0;
 // Vitesses de Rotation, Translation, Echelle, Zoom, Evidement + pas des glissières
var speedR, speedT, speedE, speedZ, speedV, pas;
// Les min et max de ces vitesses, seront min et max des glissières corespondantes
var speeds, speedsMin, speedsMax;
// valeurs, min et max des glissières utilisateur
var g1, g2, g3;
var valG1, minG1, maxG1, valG2, minG2, maxG2, valG3, minG3, maxG3;
// Valeurs initiales de ces glissières
var valG1Init, valG2Init, valG3Init, pasG1, pasG2, pasG3;
// Noms de ces glissières
var nomG1, nomG2, nomG3;
// Présence ou non de ces glissières
var gg1 = false, gg2 = false, gg3 = false;
// Positions
var posX, posY, posCamX, posCamY, posCamZ, posCamX0, posCamY0;
// Actions globales
var rotX = 0, rotY = 0, transX = 0, transY = 0, rotX0 = 0, rotY0 = 0, transX0 = 0, transY0 = 0;
// Mémoires des actions déjà appliquées aux Faces
var transFaces = [], addEchFaces = [], addVideFaces = [];
var sommetsTemp = [], facesTemp = [], couleursTemp = [];
var sommets = [], sommetsAux = [], couleurs = [], lesFaces = [];
var ppu = 1; // Pixels par unité
var canvasSPAF; // Le canvas
// Tableau des contrôles
var gui;
var titres = [], gliss = [];
// Pour les actions
var textes = [], codes = [];
var actions, composantes;
var drag = false;
// Pour les dialogues
var divMulti, b, b1, t = [],
    titresInputs = ['Nom de base des images', 'Extension(png/jpg)',
                    'Durée (en secondes)', "Nombre d'images par seconde"];
var div1, b2, b3, s = [], titresInputs2 = ["Nom de l'image", 'Extension(png/jpg)'];
var divOuvert;
var couleurFondSPAF; // mod AB
var toucherX, toucherY; // mod AB
var derniereTouchePressee=""; // mod AB
// ----------------------------------------------------------------------
function definirSommet(num, x, y, z){
  var a = [num, x, y, z];
  sommetsTemp.push(a);
}

function definirFace(num, s1, s2, s3){
	if(arguments.length == 0 || arguments.length == 3 || arguments.length == 1){return;}
	var u = [];
  if (arguments.length == 2){
		if(arguments[1].length < 3){return;}
		u = arguments[1];
		u.unshift(arguments[0]);
	}else{
		for(var i = 0; i < arguments.length; i++){
			u[i] = arguments[i];
		}
	}
  facesTemp.push(u);
}

function couleurFace(num, r, g, b){
  var u = [num, round(r), round(g), round(b)];
  couleursTemp.push(u);
}

function construireTableauSommets(){
  var nbSommets = sommetsTemp.length;
  for(var i = 0; i < nbSommets; i++){
    var u = sommetsTemp[i];
    var num = round(u[0]);
    sommets[num-1] = createVector(u[1]*ppu, u[2]*ppu, u[3]*ppu);
    sommetsAux[num-1] = createVector(u[1]*ppu, u[2]*ppu, u[3]*ppu);
  }
}

function construireTableauCouleurs(){
  var nbCouleurs = facesTemp.length;
  for(var i = 0; i < nbCouleurs; i++){
    couleurs[i] = color(round(random(256)), round(random(256)), round(random(256)));
  }
  for(var j = 0; j < couleursTemp.length; j++){
    var l = couleursTemp[j];
    var num = l[0];
    couleurs[num-1] = color(l[1], l[2], l[3]);
  }
}

function construireFigure(){
  construireTableauSommets();
  construireTableauCouleurs();
  for(var i = 0; i < facesTemp.length; i++){
    var sommetsFace = [];
    var u = facesTemp[i];
    var num = u[0];
    for(var j = 1; j < u.length; j++){
      sommetsFace[j-1] = sommets[u[j]-1];
    }
    lesFaces[num-1] = new Face(sommetsFace);
    lesFaces[num-1].couleur = couleurs[i];
  }
}

function construireGui(gauche, haut){
  var inc1 = 35, inc2 = 20;
  pas = 0.2;
  gui = createDiv('').size(300, 800).position(810, 0);
  gui.style("background-color", "#EEEEEE"); // mod AB
  for(var i = 1; i <= titres.length; i++){
    var tg = createP(titres[i-1]).parent(gui);
    tg.position(gauche, haut);
    haut += inc1;
    gliss[i] = createSlider(speedsMin[i-1], speedsMax[i-1],speedsMin[i-1], pas).parent(gui);
    gliss[i].position(gauche, haut);
    gliss[i].size(200);
    haut += inc2;
  }
  haut += inc2;
  if(gg1){
    g1 = createSlider(minG1, maxG1, valG1Init, pasG1).parent(gui);
    var tg = createP(nomG1).parent(gui);
    tg.position(gauche, haut);
    haut += inc1;
    g1.position(gauche, haut);
    g1.size(200);
    haut += inc2;
  }
  if(gg2){
    g2 = createSlider(minG2, maxG2, valG2Init, pasG2).parent(gui);
    var tg = createP(nomG2).parent(gui);
    tg.position(gauche, haut);
    haut += inc1;
    g2.position(gauche, haut);
    g2.size(200);
    haut += inc2;
  }
  if(gg3){
    g3 = createSlider(minG3, maxG3, valG3Init, pasG3).parent(gui);
    var tg = createP(nomG3).parent(gui);
    tg.position(gauche, haut);
    haut += inc1;
    g3.position(gauche, haut);
    g3.size(200);
    haut += inc2;
  }
  haut += inc2;
	var tailleFont = "11pt";
  var bt = createButton('Réinitialiser(i)').parent(gui);
  bt.position(gauche + 60, haut).style("font-size", tailleFont);
  bt.mousePressed(initialisation);
  haut += inc2;
	// Boutons pour prendre photos
	var tt = createP('Enregistrer :').parent(gui);
	tt.position(gauche + 75, haut);
	haut += inc1+6;
	var bouton1ph = createButton("l'image(p)").parent(gui);
	bouton1ph.position(gauche, haut).style("font-size", tailleFont);
	bouton1ph.mousePressed(ouvrirDiv1);
	var bouton2ph = createButton("une série d'images(m)").parent(gui);
	bouton2ph.position(gauche + 100, haut).style("font-size", tailleFont);
	bouton2ph.mousePressed(ouvrirDivMulti);
	haut += inc2 + 15;
  var ts = createP("Actions").parent(gui);
  ts.position(gauche + 20, haut);
  var hautTemp = haut;
  haut += inc1 + 5;
  actions = createElement('select').parent(gui);
  actions.name='Actions';
  actions.position(gauche + 20, haut).style("font-size", tailleFont);
  for(var i = 0; i < textes.length; i++){
    var action = createElement('option').parent(gui);
    action.value(codes[i]);
    action.html(textes[i]);
    actions.child(action);
  }
  actions.changed(actionsEvent);
  haut = hautTemp;
  ts = createP('Face active').parent(gui);
  ts.position(gauche + 160, haut);
  haut += inc1 + 5;
  composantes = createElement('select').parent(gui);
  composantes.name = 'Face active';
  composantes.position(gauche + 160, haut).style("font-size", tailleFont);
  var f = createElement('option');
  f.value('Toutes');
  f.html('Toutes');
  composantes.child(f);
  for(var i = 1; i <= facesTemp.length; i++){
    f = createElement('option');
    f.value(i);
    f.html('Face ' + i);
    composantes.child(f);
  }
  composantes.changed(composEvent);
  haut += inc2;
  creationDivMulti();
  divMulti.hide();
  creationDiv1();
  div1.hide();
  divOuvert = false;
}

function creationDivMulti(){
	var tailleFont = "11pt";
  divMulti = createDiv('').size(250, 360).style("background-color", '#eee'); // mod AB
  divMulti.style("font-weight", "bold");
  divMulti.position(830, 40);
  var haut = 10, marge = 15;
  for(var i = 0; i < 4; i++){
    createP(titresInputs[i]).parent(divMulti).position(marge - 5, haut).size(240);
    haut += 40;
		//if (i == 3){haut += 40;}
    t[i] = createInput('').parent(divMulti).position(marge, haut);
    haut += 30;
  }
    b = createButton('Enregistrer').parent(divMulti).position(20, haut + 10).style('font-size', tailleFont);
    b.mouseClicked(sauverImages);
    b1 = createButton('Annuler').parent(divMulti).position(125, haut + 10).style('font-size', tailleFont);
    b1.mouseClicked(annuler);
}

function creationDiv1(){
		var tailleFont = "11pt";
    div1 = createDiv('').size(235, 200).style("background-color", '#eee'); // mod AB
    div1.style("font-weight", "bold");
    div1.position(830, 40);
    var haut = 10, marge = 15;
    for(var i = 0; i < 2; i++){
      createP(titresInputs2[i]).parent(div1).position(marge - 5, haut).size(220);
      haut += 40;
      s[i] = createInput('').parent(div1).position(marge, haut);
      haut += 30;
    }
    b2 = createButton('Enregistrer').parent(div1).position(20, haut + 10).style('font-size', tailleFont);
    b2.mouseClicked(sauverImage);
    b3 = createButton('Annuler').parent(div1).position(120, haut + 10).style('font-size', tailleFont);
    b3.mouseClicked(annuler);
}

function sauverImages(){
  var nom = t[0].value();
  var extension = t[1].value();
  var duree = parseInt(t[2].value());
  var frequence = max(parseInt(t[3].value()), 1); // Le min est 1
  divMulti.hide();
  for(var i = 0; i < 4; i++){
    t[i].value('');
  }
  divOuvert = false;
  if(controlesVisibles){gui.show();}
  saveFrames(nom, extension, duree, frequence);
}

function sauverImage(){
  var nom = s[0].value();
  var extension = s[1].value();
  div1.hide();
  for(var i = 0; i < 2; i++){
    s[i].value('');
  }
  divOuvert = false;
  if(controlesVisibles){gui.show();}
  saveCanvas(nom, extension);
}

function annuler(){
  divOuvert = false;
  divMulti.hide();
  div1.hide();
	if(controlesVisibles){gui.show();}
  for(var i = 0; i < 4; i++){
    t[i].value('');
  }
  for(var i = 0; i < 2; i++){
    s[i].value('');
  }
}

function actionsEvent(){
  var num = actions.elt.selectedIndex;
  mode = codes[num];
  if(mode == 'rot' || mode == 'zoom'){
    composantes.value('Toutes');
    compos = 0;
  }
}

function composEvent(){
  var num = composantes.elt.selectedIndex;
  compos = num;
  if((mode == 'rot' || mode == 'zoom') && compos > 0){
    mode = 'rien'; actions.value('rien');
  }
}

function redefinirSommet(i, x, y, z){
  sommetsAux[i-1] = createVector(x*ppu, y*ppu, z*ppu);
  // Chercher les faces concernées
  for(var j = 0; j < facesTemp.length; j++){
    var t = facesTemp[j];
    var num = t[0]; // numéro de la face
    // le sommet i est-il dans la face
    for(var k = 1; k < t.length; k++){
      if(t[k] == i){// si le sommet #i est en position k dans la face
        lesFaces[num-1].modifierSommet(k-1, createVector(x*ppu, y*ppu, z*ppu));
      }
    }
  }
}

function creerGlissiereG1(min, max, valInit, pas, nom){
  if (arguments.length == 5){
    nomG1 = arguments[4];
  }else{// Sinon le nom par défaut est "G1"
    nomG1 = 'G1';
  }
  minG1 = min;
  maxG1 = max;
  valG1 = valInit;
  valG1Init = valInit;
  pasG1 = pas;
  gg1 = true;
}

function creerGlissiereG2(min, max, valInit, pas, nom){
  if (arguments.length == 5){
    nomG2 = arguments[4];
  }else{
    nomG2 = 'G2';
  }
  minG2 = min;
  maxG2 = max;
  valG2 = valInit;
  valG2Init = valInit;
  pasG2 = pas;
  gg2 = true;
}

function creerGlissiereG3(min, max, valInit, pas, nom){
  if (arguments.length == 5){
    nomG3 = arguments[4];
  }else{
    nomG3 = 'G3';
  }
  minG3 = min;
  maxG3 = max;
  valG3 = valInit;
  valG3Init = valInit;
  pasG3 = pas;
  gg3 = true;
}

function initialisation(){
  // init Camera
  posCamZ = 500;
  posCamX = 0; posCamY = 0;
	posCamX0 = 0; posCamY0 = 0;
  camera(posCamX, posCamY, posCamZ);
  // init Translations
  transX = 0; transY = 0; transX0 = 0; transY0 = 0;
  for(var i = 0; i < lesFaces.length; i++){
    transFaces[i] = 0;
    addEchFaces[i] = 0;
    addVideFaces[i] = 0;
    lesFaces[i].echelle = 1;
    lesFaces[i].setPourCentTrou(0);
  }
  // init rotations
  rotX = 0; rotY = 0; rotX0 = 0; rotY0 = 0;
  // init Faces
  for(var i = 0; i< lesFaces.length; i++){
    lesFaces[i].init();
    lesFaces[i].couleur = couleurs[i];
  }
  // Les glissières et vitesses
  speedR = speedsMin[0]; gliss[1].value(speedR);
  speedT = speedsMin[1]; gliss[2].value(speedT);
  speedE = speedsMin[2]; gliss[3].value(speedE);
  speedZ = speedsMin[3]; gliss[4].value(speedZ);
  speedV = speedsMin[4]; gliss[5].value(speedV);

  valG1 = valG1Init;
  valG2 = valG2Init;
  valG3 = valG3Init;

  if(gg1){g1.value(valG1);}
  if(gg2){g2.value(valG2);}
  if(gg3){g3.value(valG3);}

  // les sommets auxiliaires
  for(var i = 0; i < sommets.length; i++){
    sommetsAux[i] = createVector(sommets[i].x, sommets[i].y, sommets[i].z);
  }
  mode = 'rien';
  compos = 0;
  actions.value(mode);
  composantes.value('Toutes');
  initialiserFigure(); // déplaçé AB
}

function setup() {
  titres = ['Vitesse de rotation', 'Vitesse de translation', "Vitesse d'échelle", 'Vitesse de zoom', "Vitesse d'évidement"];
  speedsMin = [8, 3, 1, 5, 1];
  speedsMax = [30, 50, 30, 10, 50];
  definirFigure();
  construireFigure();
  canvasSPAF = createCanvas(800, 800, WEBGL);
  canvasSPAF.position(0, 0);
  // Pour le GUI
  textes = ['Rotation (r)', 'Translation (t)', 'Échelle (e)', 'Zoom (z)', 'Visibilité (v)', 'Face creuse (c)', 'Rien (a)'];
  codes = ['rot', 'trans', 'ech', 'zoom', 'vis', 'creux', 'rien'];
  construireGui(20, 20);
  couleurFondSPAF=200; // mod AB    background(128);
  initialisation(); // mod AB (ordre)
  translate(width/2 + transX, height/2 + transY, 0);
  rotateX(rotX);
  rotateY(rotY);
  for(var i = 0; i < lesFaces.length; i++){
    lesFaces[i].display();
  }
}

function draw() {
	activationTouches();
	if (keyIsPressed && !divOuvert){
		derniereTouchePressee = key; // mod AB
		if(key == 'r' && etatClavier.r){mode = 'rot'; actions.value('rot');}
		if(key == 't' && etatClavier.t){mode = 'trans'; actions.value('trans');}
		if(key == 'e' && etatClavier.e){mode = 'ech'; actions.value('ech');}
		if(key == 'z' && etatClavier.z){mode = 'zoom'; actions.value('zoom');}
		if(key == 'v' && etatClavier.v){mode = 'vis'; actions.value('vis');}
		if(key == 'a' && etatClavier.a){mode = 'rien'; actions.value('rien');}
		if(key == 'c' && etatClavier.v){mode = 'creux'; actions.value('creux');}
    if( key >= 1  && key <= min(9, lesFaces.length)){
      compos = key;
      if (mode == 'rot' || mode == 'zoom'){
        composantes.value('Toutes');
      }else{
        composantes.elt.selectedIndex = compos;
      }
	   }
    if ((key == '+' || key == '=') && (mode == 'rot')){
      speedR = gliss[1].value();
      gliss[1].value(min(speedR + 0.2, speedsMax[0]));
    }
    if ((key == '-') && (mode == 'rot')){
      speedR = gliss[1].value();
      gliss[1].value(max(speedR - 0.2, speedsMin[0]));
    }

    if ((key == '+' || key == '=') && (mode == 'trans')){
      speedT = gliss[2].value();
      gliss[2].value(min(speedT + 0.2, speedsMax[1]));
    }
    if ((key == '-') && (mode == 'trans')){
      speedT = gliss[2].value();
      gliss[2].value(max(speedT - 0.2, speedsMin[1]));
    }

    if ((key == '+' || key == '=') && (mode == 'ech')){
      speedE = gliss[3].value();
      gliss[3].value(min(speedE + 0.2, speedsMax[2]));
    }
    if ((key == '-') && (mode == 'ech')){
      speedE = gliss[3].value();
      gliss[3].value(max(speedE - 0.2, speedsMin[2]));
    }

    if ((key == '+' || key == '=') && (mode == 'zoom')){
      speedZ = gliss[4].value();
      gliss[4].value(min(speedZ + 0.2, speedsMax[3]));
    }
    if ((key == '-') && (mode == 'zoom')){
      speedZ = gliss[4].value();
      gliss[4].value(max(speedZ - 0.2, speedsMin[3]));
    }

    if ((key == '+' || key == '=') && (mode == 'creux')){
      speedV = gliss[5].value();
      gliss[5].value(min(speedV + 0.2, speedsMax[4]));
    }
    if ((key == '-') && (mode == 'creux')){
      speedV = gliss[5].value();
      gliss[5].value(max(speedV - 0.2, speedsMin[4]));
    }
  }
  if(gg1){valG1 = g1.value();}
  if(gg2){valG2 = g2.value();}
	if(gg3){valG3 = g3.value();}
  if (inCanvas() && clicP() && !divOuvert){
    if (drag){
      if(mode == 'rot'){
        speedR = gliss[1].value();
        rotX = rotX0 + (speedR/10)*(posY - toucherY)/300;
        rotY = rotY0 + (speedR/10)*(posX - toucherX)/300;
      }
      if(mode == 'trans'){
        speedT = gliss[2].value();
        if(compos == 0){
          transX = transX0 +(speedT/10)*(toucherX - posX);
          transY = transY0 +(speedT/10)*(toucherY - posY);
        }else{
          var p = speedT/10 *(toucherX + toucherY - posX - posY);
          p += transFaces[compos-1];
          lesFaces[compos-1].setTranslationN(p);
        }
      }
      if(mode == 'zoom'){
        speedZ = gliss[4].value();
        posCamX = posCamX0 + (toucherX - posX);
        posCamY = posCamY0 + (toucherY - posY);
        // camera();
        posCamZ = posCamZ - speedZ * sens;t
      }
      if (mode == 'ech'){
        speedE = gliss[3].value();
        var e = (speedE/10) * (toucherX + toucherY - posX - posY)/300;
        if(compos == 0){
          for(var i = 0; i < lesFaces.length; i++){
            lesFaces[i].setEchelle(e + addEchFaces[i]);
          }
        }else{
          lesFaces[compos-1].setEchelle(e + addEchFaces[compos-1]);
        }
      }
      if (mode == 'creux'){
        speedV = gliss[5].value();
        var e = (speedV/10 ) * (toucherX + toucherY - posX - posY)/300;
        if (compos == 0){
          for(var i = 0; i < lesFaces.length; i++){
            lesFaces[i].setPourCentTrou(e + addVideFaces[i]);
          }
        }else{
          lesFaces[compos - 1].setPourCentTrou(e + addVideFaces[compos - 1]);
        }
      }
    }
   }else{
      drag = false;
      if(mode == 'trans' && compos > 0){
        transFaces[compos-1] = lesFaces[compos-1].translationNum;
      }
      if(mode == 'ech'){
        for(var i=0;i < lesFaces.length; i++){
          addEchFaces[i] = lesFaces[i].echelle;
        }
      }
      if(mode == 'creux'){
        for(var i=0;i < lesFaces.length; i++){
          addVideFaces[i] = lesFaces[i].t;
        }
      }
  }

  background(couleurFondSPAF); // mod AB
	camera(posCamX, posCamY, posCamZ); // Doit être avant les transformations
  translate(transX, transY, 0);
  rotateX(rotX);
  rotateY(rotY);
  redefinirCertainsSommets();
  for(var i = 0; i < lesFaces.length; i++){
    lesFaces[i].display();
  }
}

function inCanvas(){
  clicP();
  return (toucherX > 0 && toucherX < width && toucherY > 0 && toucherY < height);
}

function mousePressed(){ // mod AB
  if (!inCanvas() || divOuvert){drag = false; // MG
  }else{
    drag = true;
    if( mode == 'rot'){
      rotX0 = rotX; rotY0 = rotY;
      posX = toucherX; posY = toucherY;
      composantes.value('Toutes');
    }
    if (mode == 'trans'){
      posX = toucherX; posY = toucherY;
      if (compos == 0){ // toutes les faces
        transX0 = transX; transY0 = transY;
      }
    }
    if(mode == 'ech' || mode == 'creux'){
      posX = toucherX; posY = toucherY;
    }

    if(mode == 'zoom'){
      composantes.value('Toutes');
      posX = toucherX; posY = toucherY;
      posCamX0 = posCamX; posCamY0 = posCamY;
      if((mouseIsPressed && (mouseButton == LEFT)) || (touchIsDown && (touches.length < 2))){ // mod AB
        sens = 1;
      }else{
        sens = -1;
      }
    }
    if(mode == 'vis'){
      if(compos == 0){
        for(var i = 0; i < lesFaces.length; i++){
          var b = lesFaces[i].visible;
          lesFaces[i].visible = !b;
        }
      }else{
        var b = lesFaces[compos-1].visible;
        lesFaces[compos-1].visible = !b;
      }
    }
  }
}

function mouseReleased(){
  drag = false;
  if(inCanvas() && !divOuvert){ //MG
    if(mode == 'trans' && compos > 0){
      transFaces[compos-1] = lesFaces[compos-1].translationNum;
    }
    if(mode == 'ech'){
      for(var i=0;i < lesFaces.length; i++){
        addEchFaces[i] = lesFaces[i].echelle;
      }
    }
    if(mode == 'creux'){
      for(var i=0;i < lesFaces.length; i++){
        addVideFaces[i] = lesFaces[i].t;
      }
    }
	}
}

function keyReleased(){
  if((key == 'p' || key == 'P') && !divOuvert && etatClavier.p){
		ouvrirDiv1();
  }
  if((key == 'm' || key == 'M') && !divOuvert && etatClavier.m){
    ouvrirDivMulti();
  }
	if((key == 'i' || key == 'I') && !divOuvert && etatClavier.i){
		initialisation();
	}
}

function ouvrirDiv1(){
	gui.hide();
  div1.show();
	s[0].elt.focus();
  divOuvert = true;
}

function ouvrirDivMulti(){
  gui.hide();
  divMulti.show();
	t[0].elt.focus();
  divOuvert = true; 
}

//***************** Programmation utilisateur *******************
function pixelsParUnite(x){
  ppu = abs(x);
  if (ppu=== 0){ppu = 1;}
}

function xSommet(i){
  return sommetsAux[i-1].x/ppu;
}

function ySommet(i){
  return sommetsAux[i-1].y/ppu;
}

function zSommet(i){
  return sommetsAux[i-1].z/ppu;
}

function fixeEchelle(i, val){ // i  0 c'est toutes les faces
  if (i <0 || i > lesFaces.length){return;}
  if (i == 0){
    for(var j = 0; j < lesFaces.length; j++){
      lesFaces[j].echelle = val;
    }
  }else{
    lesFaces[i-1].echelle = val;
  }
}

function donneEchelle(i){
  if (i < 1 || i > lesFaces.length){return null;} // null si la face n'existe pas
  return lesFaces[i-1].echelle;
}

function fixeVisible(i, b){
  if (i <0 || i > lesFaces.length){return;} // i = 0 c'est toutes les faces
  if (i == 0){
    for(var j = 0; j < lesFaces.length; j++){
      lesFaces[j].visible = b;
    }
  }else{
    lesFaces[i-1].visible = b;
  }
}

function donneVisible(i){
  if (i < 1 || i > lesFaces.length){return false;} // si la face n'existe pas
  return lesFaces[i-1].visible;
}

function fixeTailleCreux(i, s){ // s entre 0 et 1, pourcentage de trou
  if (i < 0 || i > lesFaces.length){return;} // la face n'existe pas
  s = min(max(s, 0), 1);
  if (i == 0){
    for(var j = 0; j < lesFaces.length; j++){
      lesFaces[j].t = s;
    }
  }else{
    lesFaces[i-1].t = s;
  }
}

function donneTailleCreux(i){
  if (i < 1 || i > lesFaces.length){return 0;} // si la face n'existe pas
  return lesFaces[i-1].t;
}

function integrerDansFigure(i, b){
  if (i < 0 || i > lesFaces.length){return;}
   if (i == 0){
    for(var j = 0; j < lesFaces.length; j++){
      lesFaces[j].partieDeLaFigure = b;
    }
  }else{
    lesFaces[i-1].partieDeLaFigure = b;;
  }
}

function donneDansFigure(i){
  if (i < 1 || i > lesFaces.length){return false;} // si la face n'existe pas
  return lesFaces[i-1].partieDeLaFigure;
}

function fixeCouleur(i, r, g, b){ // seulement pour les faces individuelles
  if (i < 1 || i > lesFaces.length){return;}
  lesFaces[i-1].couleur = color(r, g, b);
}

function changerCouleur(i, r, g, b){
	fixeCouleur(i, r, g, b);
}

function donneCouleur(i){
  if (i < 1 || i > lesFaces.length){return color(0, 0, 0);} // si la face n'existe pas : noir
  return lesFaces[i-1].color;
}

function donneRouge(i){
  if (i < 1 || i > lesFaces.length){return 0;} // si la face n'existe pas : pas de rouge
  return red(lesFaces[i-1].couleur);
}

function donneVert(i){
  if (i < 1 || i > lesFaces.length){return 0;} // si la face n'existe pas : pas de vert
  return green(lesFaces[i-1].couleur);
}

function donneBleu(i){
  if (i < 1 || i > lesFaces.length){return 0;} // si la face n'existe pas : pas de bleu
  return blue(lesFaces[i-1].couleur);
}

// Translations des faces individuelles
function fixeTranslation(i, t){
  if (i < 1 || i > lesFaces.length){return;}
  lesFaces[i-1].setTranslationN(t*ppu);
}

function donneTranslation(i){
  if (i < 1 || i > lesFaces.length){return 0;}
  return lesFaces[i-1].translationN/ppu;
}
// Transformations globales : translations et rotations
function fixeTranslationX(t){
  transX = t*ppu;
}

function fixeTranslationY(t){
  transY = t*ppu;
}

function donneTranslationX(){
  return transX/ppu;
}

function ajouteTranslationX(x){
  transX += x*ppu;
}

function ajouteTranslationY(x){
  transY += x*ppu;
}

function donneTranslationY(){
  return transY/ppu;
}

function fixeRotationY(r){ // r = degrés
  rotY = r * PI/180;
}

function ajouteRotationY(r){
  rotY += r * PI/180;
}

function fixeRotationX(r){
  rotX = r*PI/180;
}

function ajouteRotationX(r){
  rotX += r * PI/180;
}

function donneRotationX(){
  return rotX * 180/PI;
}

function donneRotationY(){
  return rotY * 180/PI;
}

function cacherControles(){
	gui.hide();
	div1.hide();
	divMulti.hide();
	divOuvert = false;
	etatClavier = {r: false, t: false, e: false, z: false, v: false, c: false, a: false, i: false, p: false, m: false};
	activerTouches = [];
	controlesVisibles = false;
}

function montrerControles(){
	gui.show();
	etatClavier = {r: true, t: true, e: true, z: true, v: true, c: true, a: true, i: true, p: true, m: true};
	activerTouches = [];
	controlesVisibles = true;
}

function afficheLigne(a){
	for(var i = 0; i < arguments.length; i++){
		console.log('' + arguments[i] + '\n');
	}
}

function affiche(a){
	var texte = arguments[0];
	for(var i = 1; i < arguments.length; i++){
		texte += ', '+arguments[i];
	}
	console.log(texte);
}

function afficheS(sep, a){
	var texte = arguments[1];
	for(var i = 2; i < arguments.length; i++){
		texte += sep + arguments[i];
	}
	console.log(texte);
}

function prendrePhoto(nom, extention){
	saveCanvas(nom, extention);
}

//*********************************************************************************
// Ajouts après 28/03/2017

var etatClavier = {r: true, t: true, e: true, z: true, v: true, c: true, a: true, i: true, p: true, m: true};
var activerTouches = [];
var controlesVisibles = true;

function debloquerTouches(){// Fonction utilisateur autant d'arguments que désirés voir 'activationTouches' ci-dessous
	for(var i = 0; i < arguments.length; i++){
		activerTouches.push(arguments[i]);
	}
}

function bloquerClavier(){
	etatClavier = {r: false, t: false, e: false, z: false, v: false, c: false, a: false, i: false, p: false, m: false};
	activerTouches = [];
}

function libererClavier(){
	etatClavier = {r: true, t: true, e: true, z: true, v: true, c: true, a: true, i: true, p: true, m: true};
	activerTouches = [];
}

function activationTouches(){
	if(activerTouches.includes('r')){etatClavier.r = true;}
	if(activerTouches.includes('t')){etatClavier.t = true;}
	if(activerTouches.includes('e')){etatClavier.e = true;}
	if(activerTouches.includes('z')){etatClavier.z = true;}
	if(activerTouches.includes('v')){etatClavier.v = true;}
	if(activerTouches.includes('c')){etatClavier.c = true;}
	if(activerTouches.includes('a')){etatClavier.a = true;}
	if(activerTouches.includes('i')){etatClavier.i = true;}
	if(activerTouches.includes('p')){etatClavier.p = true;}
	if(activerTouches.includes('m')){etatClavier.m = true;}
}

function trouverPosition(obj) { // mod AB
	var curleft = curtop = 0;
	if (obj.offsetParent) {
  	do {
			curleft += obj.offsetLeft;
			curtop += obj.offsetTop;
 		} while (obj = obj.offsetParent);
		return [curleft,curtop];
  }
}

function modifierCouleurFondSPAF(r, v, b) { // mod AB
	couleurFondSPAF=color(r,v,b);
}

function etatInitialSPAF(touche) {  // mod AB
	if (touche =='r') {mode = 'rot'; actions.value('rot')};
	if (touche =='t') {mode = 'trans'; actions.value('trans')};
	if (touche =='e') {mode = 'ech'; actions.value('ech')};
	if (touche =='z') {mode = 'zoom'; actions.value('zoom')};
	if (touche =='v') {mode = 'vis'; actions.value('vis')};
	if (touche =='c') {mode = 'creux'; actions.value('creux')};
	if (touche =='a') {mode = 'rien'; actions.value('rien')};
}; 

function recadrerSPAF() {  // mod AB
	var divSPAF = select('#contenantSPAF'); 
	var posXY = trouverPosition(divSPAF.elt);	
    canvasSPAF.position(posXY[0],posXY[1]); gui.position(810+posXY[0],posXY[1]); 
    div1.position(830+posXY[0],40+posXY[1]); divMulti.position(830+posXY[0],40+posXY[1]);
	
}

//***********************************************************

function clicP() {  // mod AB
	if (mouseIsPressed) {toucherX=mouseX; toucherY=mouseY;}
	if (touchIsDown) {toucherX=touchX; toucherY=touchY;} 
	return mouseIsPressed || touchIsDown;
}

function touchStarted(){  // mod AB
  mousePressed();
  if (touchIsDown  && inCanvas()) {return false;};
}

function touchEnded(){  // mod AB
  mouseReleased();
}