var glissiereN, glissiereH, glissiereR, pN, pH, pR;

function definirFigure(){
  pixelsParUnite(150);
  
  // ajusterGlissiere si nécessaire
  creerGlissiereG1(3, 20, 20, 1, "nb de  triangles");  // nombre de côtés du polygone
  creerGlissiereG2(-4, 4, 4, 0.01, "hauteur");    // hauteur du sommet
  creerGlissiereG3(0, 2, 2, 0.01, "rayon");    // rayon supérieur
  
  // Définition des sommets
  for(var k=0;k<=20;k++) {
    definirSommet(k+1,2*cos(k*PI/10),0,2*sin(k*PI/10));
    definirSommet(k+22,2*cos(k*PI/10+PI/20),-2,2*sin(k*PI/10+PI/20));
  }
  
  // Définition des faces
  var coul;
  for(var  k=1;k<=20;k++) {
    definirFace(k, k,k+1,k+21);
    if (k % 2 == 0) {coul=round(k*255.0/20);} else {coul=255-round(k*255.0/20);}
    couleurFace(k,255, coul, 255-coul);
  }
}

function initialiserFigure(){
    fixeRotationX(20);
}

function redefinirCertainsSommets(){
    var nb = round(valG1);
    var h = -valG2;
    var r = valG3;
    
    for(var k=0;k<=nb;k++) {
      redefinirSommet(k+1,2*cos(k*2*PI/nb),0,2*sin(k*2*PI/nb));
      redefinirSommet(k+22,r*cos(k*2*PI/nb+PI/nb),h,r*sin(k*2*PI/nb+PI/nb));
    }
    for(var k=1;k<=nb;k++) {
      integrerDansFigure(k,true);
    }
    for(var k=nb+1;k<=20;k++) {
      integrerDansFigure(k,false);
    }
}